unit uConnectForm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls, IniFiles, dOPC;

type
  TOPCConnectForm = class(TForm)
    TopPanel: TPanel;
    Label2: TLabel;
    bRemoteConnect: TSpeedButton;
    BDisconnect: TSpeedButton;
    bConnect: TSpeedButton;
    ServerCombo: TComboBox;
    OPCServer: TdOPCServer;
    procedure ServerComboDropDown(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure bRemoteConnectClick(Sender: TObject);
    procedure bConnectClick(Sender: TObject);
    procedure BDisconnectClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure OPCServerConnect(Sender: TObject);
    procedure OPCServerDisconnect(Sender: TObject);
  private
    Inifile : TIniFile;
    procedure Connect(ComputerName: string);
    procedure SetButtons;
  public
  end;

var
  OPCConnectForm: TOPCConnectForm;

implementation

{$R *.DFM}

procedure TOPCConnectForm.Connect(ComputerName: string);
begin
   if Trim(ServerCombo.Text) <> '' then
   begin
     OpcServer.Computername   := ComputerName;
     OpcServer.ServerName     := ServerCombo.Text;   // set Servername from Combobox
     OpcServer.Active         := true;               // connect to Server
     IniFile.WriteString('SERVER','LAST',OpcServer.ServerName);
   end
   else
     ShowMessage('first select OPC Server');
end;


procedure TOPCConnectForm.ServerComboDropDown(Sender: TObject);
begin
  if trim(ServerCombo.Items.Text) = '' then  // if no OPC Servernames loaded
  begin
    Screen.Cursor := crHourGlass;
    GetOPCServers(ServerCombo.Items);        // get Servernames from registry
    Screen.Cursor := crDefault;
  end;
end;

procedure TOPCConnectForm.FormCreate(Sender: TObject);
begin
  IniFile := TIniFile.Create(ChangeFileExt(Application.ExeName,'.ini'));
end;

procedure TOPCConnectForm.FormDestroy(Sender: TObject);
begin
  IniFile.Free;
end;

procedure TOPCConnectForm.bRemoteConnectClick(Sender: TObject);
var
  CName : string;
begin
   CName := '';
   if InputQuery('Select remote Computer','Computername',CName) then
     Connect(CName);
end;

procedure TOPCConnectForm.bConnectClick(Sender: TObject);
begin
  Connect('');
end;

procedure TOPCConnectForm.BDisconnectClick(Sender: TObject);
begin
  OPCServer.Active := false;
end;

procedure TOPCConnectForm.FormShow(Sender: TObject);
begin
  SetButtons;
  ServerCombo.Text := IniFile.ReadString('SERVER','LAST','');
end;

procedure TOPCConnectForm.SetButtons;
begin
  BConnect.Enabled         := not OpcServer.Active;
  bRemoteConnect.Enabled   := not OpcServer.Active;
  BDisconnect.Enabled      := OpcServer.Active;
end;


procedure TOPCConnectForm.OPCServerConnect(Sender: TObject);
begin
  SetButtons;
end;

procedure TOPCConnectForm.OPCServerDisconnect(Sender: TObject);
begin
  SetButtons;
end;

end.
